from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, Int, File

Vdb_Dump_Orig_2_10_8_V0_1_0 = CommandToolBuilder(tool="vdb_dump_orig.2.10.8", base_command=["vdb-dump-orig.2.10.8"], inputs=[ToolInput(tag="in_row_id_on", input_type=Boolean(optional=True), prefix="--row_id_on", doc=InputDocumentation(doc="print row id")), ToolInput(tag="in_line_feed", input_type=String(optional=True), prefix="--line_feed", doc=InputDocumentation(doc="line-feed's inbetween rows")), ToolInput(tag="in_colname_off", input_type=Boolean(optional=True), prefix="--colname_off", doc=InputDocumentation(doc="do not print column-names")), ToolInput(tag="in_in_hex", input_type=Boolean(optional=True), prefix="--in_hex", doc=InputDocumentation(doc="print numbers in hex")), ToolInput(tag="in_table", input_type=String(optional=True), prefix="--table", doc=InputDocumentation(doc="table-name")), ToolInput(tag="in_rows", input_type=String(optional=True), prefix="--rows", doc=InputDocumentation(doc="rows (default all)")), ToolInput(tag="in_columns", input_type=String(optional=True), prefix="--columns", doc=InputDocumentation(doc="columns (default all)")), ToolInput(tag="in_schema", input_type=String(optional=True), prefix="--schema", doc=InputDocumentation(doc="schema-name")), ToolInput(tag="in_schema_dump", input_type=Boolean(optional=True), prefix="--schema_dump", doc=InputDocumentation(doc="dumps the schema")), ToolInput(tag="in_table_enum", input_type=Boolean(optional=True), prefix="--table_enum", doc=InputDocumentation(doc="enumerates tables")), ToolInput(tag="in_column_enum", input_type=Boolean(optional=True), prefix="--column_enum", doc=InputDocumentation(doc="enumerates columns in extended form")), ToolInput(tag="in_column_enum_short", input_type=Boolean(optional=True), prefix="--column_enum_short", doc=InputDocumentation(doc="enumerates columns in short form")), ToolInput(tag="in_dna_bases", input_type=String(optional=True), prefix="--dna_bases", doc=InputDocumentation(doc="print dna-bases")), ToolInput(tag="in_max_length", input_type=Int(optional=True), prefix="--max_length", doc=InputDocumentation(doc="limits line length")), ToolInput(tag="in_indent_width", input_type=String(optional=True), prefix="--indent_width", doc=InputDocumentation(doc="indents the line")), ToolInput(tag="in_format", input_type=Int(optional=True), prefix="--format", doc=InputDocumentation(doc="output format:\ncsv ..... comma separated values on one line\nxml ..... xml-style without complete xml-frame\njson .... json-style\npiped ... 1 line per cell: row-id, column-name: value\ntab ..... 1 line per row: tab-separated values only\nfastq ... FASTQ( 4 lines ) for each row\nfastq1 .. FASTQ( 4 lines ) for each fragment\nfasta ... FASTA( 2 lines ) for each fragment if possible\nfasta1 .. one FASTA-record for the whole accession (REFSEQ)\nfasta2 .. one FASTA-record for each REFERENCE in cSRA\nqual .... QUAL( 2 lines ) for each row\nqual1 ... QUAL( 2 lines ) for each fragment if possible")), ToolInput(tag="in_id_range", input_type=Boolean(optional=True), prefix="--id_range", doc=InputDocumentation(doc="prints id-range")), ToolInput(tag="in_without_sra", input_type=Boolean(optional=True), prefix="--without_sra", doc=InputDocumentation(doc="without sra-type-translation")), ToolInput(tag="in_exclude", input_type=Boolean(optional=True), prefix="--exclude", doc=InputDocumentation(doc="exclude these columns")), ToolInput(tag="in_boolean", input_type=Boolean(optional=True), prefix="--boolean", doc=InputDocumentation(doc="defines how boolean's are printed (1,T)")), ToolInput(tag="in_obj_version", input_type=Boolean(optional=True), prefix="--obj_version", doc=InputDocumentation(doc="request vdb-version")), ToolInput(tag="in_obj_timestamp", input_type=Boolean(optional=True), prefix="--obj_timestamp", doc=InputDocumentation(doc="request object modification date")), ToolInput(tag="in_obj_type", input_type=Boolean(optional=True), prefix="--obj_type", doc=InputDocumentation(doc="report type of object")), ToolInput(tag="in_num_elem", input_type=Boolean(optional=True), prefix="--numelem", doc=InputDocumentation(doc="print only element-count")), ToolInput(tag="in_numele_msum", input_type=Boolean(optional=True), prefix="--numelemsum", doc=InputDocumentation(doc="sum element-count")), ToolInput(tag="in_phys_blobs", input_type=Boolean(optional=True), prefix="--phys-blobs", doc=InputDocumentation(doc="show physical blobs")), ToolInput(tag="in_vdb_blobs", input_type=Boolean(optional=True), prefix="--vdb-blobs", doc=InputDocumentation(doc="show VDB-blobs")), ToolInput(tag="in_phys", input_type=Boolean(optional=True), prefix="--phys", doc=InputDocumentation(doc="enumerate physical columns")), ToolInput(tag="in_readable", input_type=Boolean(optional=True), prefix="--readable", doc=InputDocumentation(doc="enumerate readable columns")), ToolInput(tag="in_idx_report", input_type=Boolean(optional=True), prefix="--idx-report", doc=InputDocumentation(doc="enumerate all available index")), ToolInput(tag="in_idx_range", input_type=Boolean(optional=True), prefix="--idx-range", doc=InputDocumentation(doc="enumerate values and row-ranges of one index")), ToolInput(tag="in_cur_cache", input_type=Boolean(optional=True), prefix="--cur-cache", doc=InputDocumentation(doc="size of cursor cache")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="--output-file", doc=InputDocumentation(doc="write output to this file")), ToolInput(tag="in_output_path", input_type=File(optional=True), prefix="--output-path", doc=InputDocumentation(doc="write output to this directory")), ToolInput(tag="in_gzip", input_type=Boolean(optional=True), prefix="--gzip", doc=InputDocumentation(doc="compress output using gzip")), ToolInput(tag="in_bzip_two", input_type=Boolean(optional=True), prefix="--bzip2", doc=InputDocumentation(doc="compress output using bzip2")), ToolInput(tag="in_output_buffer_size", input_type=Boolean(optional=True), prefix="--output-buffer-size", doc=InputDocumentation(doc="size of output-buffer, 0...none")), ToolInput(tag="in_disable_multithreading", input_type=Boolean(optional=True), prefix="--disable-multithreading", doc=InputDocumentation(doc="disable multithreading")), ToolInput(tag="in_info", input_type=Boolean(optional=True), prefix="--info", doc=InputDocumentation(doc="print info about run")), ToolInput(tag="in_spot_groups", input_type=Boolean(optional=True), prefix="--spotgroups", doc=InputDocumentation(doc="show spotgroups")), ToolInput(tag="in_merge_ranges", input_type=Boolean(optional=True), prefix="--merge-ranges", doc=InputDocumentation(doc="merge and sort row-ranges")), ToolInput(tag="in_spread", input_type=Boolean(optional=True), prefix="--spread", doc=InputDocumentation(doc="show spread of integer values")), ToolInput(tag="in_append", input_type=File(optional=True), prefix="--append", doc=InputDocumentation(doc="append to output-file, if output-file used")), ToolInput(tag="in_ngc", input_type=File(optional=True), prefix="--ngc", doc=InputDocumentation(doc="path to ngc file")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Increase the verbosity of the program\nstatus messages. Use multiple times for more\nverbosity. Negates quiet.")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="Turn off all status messages for the\nprogram. Negated by verbose.")), ToolInput(tag="in_option_file", input_type=File(optional=True), prefix="--option-file", doc=InputDocumentation(doc="Read more options and parameters from the")), ToolInput(tag="in_quit_dot", input_type=String(), position=0, doc=InputDocumentation(doc="-L|--log-level <level>           Logging level as number or enum string. One ")), ToolInput(tag="in_file_dot", input_type=File(), position=0, doc=InputDocumentation(doc="vdb-dump-orig.2.10.8 : 2.10.8"))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="write output to this file")), ToolOutput(tag="out_output_path", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_path", type_hint=File()), doc=OutputDocumentation(doc="write output to this directory")), ToolOutput(tag="out_append", output_type=File(optional=True), selector=InputSelector(input_to_select="in_append", type_hint=File()), doc=OutputDocumentation(doc="append to output-file, if output-file used"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Vdb_Dump_Orig_2_10_8_V0_1_0().translate("wdl", allow_empty_container=True)

